header
{
/**
 * Lexer for the Mile language.
 * 
 * @author Ricardo Soto
 * @since 1.5
 */

package cl.ucv.inf.milecompiler.compilers;
}

class MileLexer extends Lexer;
options{
    charVocabulary = '\3'..'\377';
    exportVocab=MileLexerVocab;
    testLiterals=false;
    k=2; // lookahead
    defaultErrorHandler=false;
}

tokens
{

   BEGIN_RW      = "begin"    ;

}


//===================================================
// Letters

   protected LETTER
      : 'a'..'z'
      | 'A'..'Z'
      ;

//===================================================
// Digits

   protected DIGIT : '0'..'9';
   
//===================================================
// Recognize literals and reserved words

   UNDERSCORE : '_';
   
   IDENT options {testLiterals=true;} // Checking Reserved Words
      : (LETTER) (LETTER|DIGIT|UNDERSCORE)*
      ;

//==================================================
// White spaces

// \t : tab
// \f : form feed
// \n : newline feed
// \r : carriage return


WS :    ((' ' | '\t' | '\f') 
        | ( '\n' | '\r' ) { newline(); }
        ) { _ttype = Token.SKIP;  }
        ;

